/* K mdcomp.c 16bit C/C++ ŃRpCюst@C */
/* 쐬 mdcmp32c.cƂ32bit C/C++ŃRpC邱!! */
#define DOS16 1   /* 16dos͒`Lɂ(32dos̏ꍇ͖) */
/* #define DOS32 1 */   /* 32dos͒`Lɂ(16bitdosł͖) */
#define MIDCOMPVER "v1.01.02"    /* <20171031p>v1.01.02 */
#define MIDCOMPCPR "(c)2000-2002,2013,2017 wnc develop"
/*
--------------------------------------------------
mdcomp.c̃CZX(QBSDX^CCZXj
2017N11 wnc develop
--------------------------------------------------
Copyright (c) 2000-2002,2013,2017 wnc / t.w.
All rights reserved.

Redistribution and use in source and binary forms,
 with or without modification, are permitted provided that 
the following conditions are met:

1. Redistributions of source code must retain the above copyright notice,
   this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright notice,
   this list of conditions and the following disclaimer in
   the documentation and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
 BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR
 ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE
 GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

/***********************************************/
/*  standard midi format data compiler for DOS */
/*     (Win32 Engine)                          */
/***********************************************/
/* 2000.12.29  32bit version(Borland C++Builder3 Pro) */
/* 2001. 1. 1  32bit version(rev) */
/* 2001. 1. 2  32bit version(complite) */
/* 2001. 1. 3  32bit & 16bit(LSI-C 86 freesoft) complite  */
/* 2001. 1.14p 16bit(Turbo C 2.01(english) freesoft) */
/*             v0.00.01 volume support and Bug delete */
/* 2001. 1.15a 16bit version power up(fmdsize max:65000)*/
/* 2001. 1.16p read 1 line Bug delete */
/* 2001. 1.17p direct midi output */
/* 2001. 6.27p Win32(GUI) >> Dos16 */
/* 2001. 6.28p Dos16 Turbo C(Eng) >> LSI-C 86 freesoft */
/* 2001. 8.30p $ command add v0.00.06 */
/* 2001. 9.23p autolr and option command.  v0.00.08 */
/* 2002. 1. 1p Copyright command(cr) v0.00.09 */
/* 2002. 2.15p source name (sn) v0.00.10 */
/* 2013. 2.23p BSDX^CCZX v1.00.00 */
/* 2017.10.03p mdcomp32v1.01 */
/* 2017.10.25p fmcompf[^och1̃oOC */
/* 2017.10.31p gccG[C v1.01.02 */
/* = v1.01.00ȍ~ Digital Mars C/C++(16bitDOS)̒ = */
/* compileƂ ->  dmc -mld mdcomp.c ōs!! */
/* ================================================= */
#include <stdio.h>
/*#include <conio.h>*/
#include <string.h>
#include <stdlib.h>
#include <ctype.h>  /* v0.00.08 */
/*#include <io.h>*/

#include "fmcomp.h"  /* pwb_ */

/* dos ver MAX 512 (32bit ver:2000) */
#ifdef DOS16
	#define LINEMAX 512    /*Ps̍ő*/
#endif
#ifdef DOS32
	#define LINEMAX 2000   /* 1line max */
#endif

#define EXECMAX 10          /*R[h̐ rev<20020215p>*/

/* dos ver MAX 64000 (32bit ver:65536) */
#ifdef DOS16
	#define CH_MEMMAX 6000+3  /*e`l̊mۃ̈*/
#endif
#ifdef DOS32
	#define CH_MEMMAX 64000+3  /*e`l̊mۃ̈*/
#endif

#define LEN_MAX 16      /*̃e[umې*/

/* dos ver MAX 65002 (32bit ver:65536) */
#define FMDMEMMAX 65002  /*fmdata̍ő*/

/* max line count (Turbo C 2.01(eng) ver:999999)<20010115a> */
#define MAXLINECNT 999999L

/* <20010114p> ő`l */
#define MAX_CH 9   /* rev<20010627p> v0.00.05 */

/* <20010120a> őyԍ */
#define MAXGAKKI 127

/* <20010115p> ő剹ʐ (RpCf[^ł) */
#define MAX_VOLUME 16

/* <20010321p> q ̍ő` */
#define MAX_Q 8
#define Q_DEF 7   /* q ̏l( Q8 (l7)) 88FH,MH݊ */

/* <20010830p> Panpot֌W($) */
#define MAX_PAN 127
#define PAN_DEF 63
#define MIN_PAN 0
/* tempo */
#define TEMPO 120  /*midiϊp*/
#define MIN_TEMPO 10 /* midi ϊp */
#define MAX_TEMPO 250 /* midi ϊp */

/* midi key adjust L[fmcompl𑝂₳ȂĂ͂Ȃ */
#define MID_ADJUST 23 /* (24łȂ̂ 0͖:fmcomp) */

/* Awp v0.00.05 */
#define MAX_RENPU 32  /* A̍ő <20010325p> */

/* ݒ\[XύX邽 */
#define OP_Q7DEF 1   /* opߗp v0.00.08 <20010907p> */
#define OP_Q8DEF 2   /* opߗp v0.00.08 <20010907p> */
#define OP_AUTOLR 3  /* opߗp v0.00.08 <20010907p> */
#define OP_MANULR 4  /* opߗp v0.00.08 <20010907p> */
#define OPSETWORK 20 /* opߗpƗ̈傫 v0.00.08 <20010907p> */

/* 쌠񒷂ő crߊ֌W */
#define COPYRMAX 63 /* crߗp v0.00.09 <20011231p> */

/* V[PX񒷂ő snߊ֌W */
#define SNAMEMAX 127 /* snߗp v0.00.10 <20020114p> */

/* l֘A v1.01.00 */
#define O4BK 480

/* Turbo C <20010627p> */
#define FALSE 0
#define TRUE 1

/* v1.01.00 ̒ǉ(20171003) */
#define FMO4 32

/*------------------------------*/
int opensource1(char *);
int rd1line(void);
int closesource1(void);
int openfmbin(void);
int wrtfmbin(void);
int wrtfmcomp(void);   /* v1.01.00 fmcomp data output 20171004p */
int closefmbin(void);
int chkexec(void); /* rev<20010627p> v0.00.05 */
int open_ch(int);
int close_ch(void);
int cdecnv(void);
int l_cdecnv(void);
int s_cdecnv(int,int);
void out_exterr(int);
void s_ch_gakki(void);
int l_lencnv(void);
int n_gakkicnv(void);
int AscToDec16(void); /* Turbo C <20010628p> */
int sub_renpu(void); /* Turbo C <20010628p> */
int a_cnt(char *);  /* Turbo C <20010628p> */
int s_cdestore(int,int); /* ڏ <20010106p> */
/* unsigned long midtmpwrt(void); */
int MidTrackOut(int,unsigned char *,long);
void MidTrackOutConductor(void);  /* Turbo C <20171003> v1.01.00 */
unsigned long midlencnv(unsigned char*,int,long m_len); /* Turbo C <20171003> v1.01.00 */
unsigned long midcdewrt(unsigned char,int,int);
unsigned long midmelwrt(unsigned char,int);
unsigned long midtmpwrt(int);
unsigned long midpanwrt(unsigned char,int); /* Turbo C <20010830p> v0.00.06 */
int option_set(void);  /* Turbo C<20010923p> v0.00.08 */
void option_checkon(int); /* Turbo C<20010923p> v0.00.08 */
int gettoken(char*,int);  /* Turbo C<20010923p> v0.00.08 */
int copyr_set(void);  /* Turbo C<20020101p> v0.00.09 */
int sname_set(void);  /* LSI-C <20020215p> v0.00.10 */

int len_and(unsigned char*,long,long *); /*<20010127p>*/
int sub_cdecnv(int *,int *); /* <20010628a> */

int f_rd_open;
static int ch_stack = 0;  /*I[vchL^*/

static unsigned long chxcnt[MAX_CH]; /* L^ʒu <20010120p> */
static unsigned char *chxmem[MAX_CH]; /* mۂԒni[p */
/* static unsigned char *fmdmem; */ /*mۂԒni[p*/

static int okutabu_ch[MAX_CH]; /* IN^[uL^ <20010114p> */
static int length_ch[MAX_CH];  /* L^(cde͂ŕύX) <20010114p> */
static int volume_ch[MAX_CH];  /* ʋL^(cde͂ŕύX) <20010114p> */
static int q_ch[MAX_CH];       /* 鎞Ԃ̊(q)<20010321p>*/

static char fmdname[512];  /*^[Qbgnamei[*/
unsigned long rd_linecount;  /*ǂݍ񂾍s*/
long chxlen[MAX_CH]; /* RpCʁiSji[p<20010127p>*/

int f_remskip = FALSE;  /* <20010126a>RgJnƏI */
int f_q_def7   = FALSE; /* RadioGroup2  88VA݊H <20010322a>v0.00.05 */
int f_auto_lr  = FALSE; /*CheckBox5Ez <20010906p>v0.00.07*/

int f_storetmp = 0; /* e|xނ rev<20010321p>*/
int ch_run_ex;        /* ݏłch̔ԍi[ <20010321p> */

int work_len[MAX_RENPU];  /*Ap <20010326a> v0.00.05 */
char work_key[MAX_RENPU];

char copyr_work[COPYRMAX+1];  /* 쌠p <20011231p> v0.00.09 */
int copyr_len;            /* 쌠̒ <20011231p> v0.00.09 */
int f_copyr_sw = FALSE; /* false=쌠͂Ȃ <20011231p> v0.00.09 */

char sname_work[SNAMEMAX+1];  /* V[PXp <20020114p> v0.00.10 */
int sname_len;           /* V[PX <20020114p> v0.00.10 */
int f_sname_sw = FALSE; /* false=V[PX͂Ȃ <20020114p> v0.00.10 */

                    /*    0   1t  1   2t  2   4t  4 */
int t_nagasa[LEN_MAX] = {255,192,128, 96, 64, 48, 32,  /*0123456*/
                          24, 16, 12,  8,  6,  4,      /*789abc*/
		           3,  2,  1 };		   /*def */
                    /*    8t  8  16t 16  32t 32 */
		    /*   64t 64  128 */

/* <20010115p> fm compiler  */
/*int t_volume[MAX_VOLUME+1] = { 0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15};*/

/* <20010115p> midi compiler   0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 */
int t_volume[MAX_VOLUME+1] = { 0,7,15,23,31,39,47,55,63,71,79,87,95,103,111,119,127};


FILE *rd_hand,*wr_hand;

static char rdwork[LINEMAX+1];

char *rdworkptr;
int chval;
unsigned char gakki;

/* v1.01.00 fmcomp data option */
int f_fmcomp;    /* ==0 midi , >=1 fmd */

int main(int argc, char **argv)
{
    int rdcnt;
    int execd;
    int chopen;
    int ext_err=0;    /*G[ԍ*/
    int f_lineloop=1; /*1̎loop,0==[vAEg*/

    static char copyrdat[] = "Standard MIDI file compiler ("
#ifdef DOS16
				"16"
#endif
#ifdef DOS32
				"32"
#endif
				"bitDOS) "
                MIDCOMPVER "\n" /* version name */
				MIDCOMPCPR "\n\n";  /* copyright */
#ifdef DOS16
    static char helpdat[] = "mdcomp"
#endif
#ifdef DOS32
    static char helpdat[] = "mdcmp32c"
#endif
				" <filename> [-f]\n"
				"-f  fmcompdat output(.fmd)\n"
				"{default SMF data output(.mid)}\n\n";

    char *c1;
    unsigned char *p;
	unsigned char *p2;  /* file ext */
    int a;
	int i;  /* for work */
	int j;  /* for work v1.01.00 */

    static unsigned char fmdname_ext[]= ".mid";  /*gq*/
	static unsigned char fmdname2ext[]= ".fmd";  /* gq */

    int f_extfund = 0; /* .1*/
    int extfundloop=1; /* 1=loop,0==loopout*/
    char *source1name;
    int fbin_hand;
	int f_rdopen = 0;  /* J 0!= v1.01.02 */

    int mcwrk;  /* b̎dlɂ킹*/
    int f_mcwrkerr; /* C̎dlɂ킹*/

	int chxlenwork; /* v1.01.00 */
	int chxcntwork; /* v1.01.00 */

/*	ch1mem = 0;
	ch2mem = 0;
	ch3mem = 0;
	fmdmem = 0;
*/
	f_fmcomp = 0;   /*  ==0 midi, >=1 fmcompdatao */

    ch_stack=0; /*<20010303p> (chԍ~X̃oO) */
    chval = 0;

	/* IvVƃ\[X */
	for(i=1;i<argc;i++)
	{
		if( (argv[i][0] != '/') && (argv[i][0] != '-') )
		{
		    c1= argv[i]; /*\[X*/
			#if 0  /* debug */
			printf("c1 : [%s]\n",c1);
			#endif
		}
		else
		{
			if( argv[i][1] == 'f' || argv[i][1] == 'F' )  /* fmcomp datao͎w */
			{
				f_fmcomp = 1;   /* ==0 midi , >= 1 fmcomp */
			}
			else
			{
				printf("parameter error!\n");
				exit(1);
			}
		}

	}
	/*  c1= argv[1]; */  /*Ń\[X*/

	/* e`l <20010114p> */
	for(i=0;i<MAX_CH;i++)
	{
		okutabu_ch[i] = 4;   /* IN^[u <20010114p> */
		length_ch[i]  = L_4; /*  <20010114p> */
		volume_ch[i]  = 10;  /* default <20010115p> */
        chxcnt[i]     = 0;   /* JE^ <20010120p> */
        chxlen[i]     = 0;   /* Si[p<20010127p> */
		if(f_q_def7 == FALSE)
        {	q_ch[i]   = Q_DEF;} /* q  <20010321p> */
		else{q_ch[i]  = Q_DEF-1;} /* q defalut(Q7:88VA݊) <20010322a> */
	}

/*  ch1cnt = 0;*/   /*JE^(ch1)*/
/*  ch2cnt = 0;*/   /*JE^(ch2)*/
/*  ch3cnt = 0;*/   /*JE^(ch3)*/

    rd_linecount = 0; /*ǂݍ݃JE^*/

	f_storetmp = 0; /* e|xނ rev<20010321p> */

    f_copyr_sw = FALSE; /*쌠\͖Ƃď <20011231p> v0.00.09 */
    copyr_len  = 0;     /* 쌠͖Ƃď<20011231p>v0.00.09*/

    f_sname_sw = FALSE; /*V[PX͖Ƃď <20020114p> v0.00.10*/
    sname_len  = 0;     /* V[PX͖Ƃď<20020114p>v0.00.10 */

    printf("%s",copyrdat);	/*copyright output*/

    /*file name test*/
    if(argc == 1){ printf("%s",helpdat);exit(0);}
    if(argc >= 4){ printf("parameter over!\n"); exit(1);}

	#if 0  /* debug 20171004 v1.01 */
	printf("fmcomp %d\n",f_fmcomp);
	#endif

/*----------------------------------------*/
/*sĂ\[Xfmdp̖O쐻*/
    if(strlen(c1) >= 500) exit(1); /*filenameE𒴂*/
    strcpy(fmdname,c1);   /*fmdnamesource fileRs[*/

    a=strlen(fmdname);   /*filename̒*/
    p=(unsigned char*)fmdname; p=p+a;     /*filenamëԍŌ*/

    while(extfundloop)
        {   if( *p == '.'){f_extfund=1;extfundloop=0;} /* .}[N rev20171003 */
            else{p--;}
            if( (unsigned char*)fmdname > p){extfundloop=0;}
        }
    if(f_extfund == 0){ p=(unsigned char*)fmdname + a;}

	if(f_fmcomp == 0)
	{
		p2 = fmdname_ext;    /* midi data (.mid) */
	}
	else
	{
		p2 = fmdname2ext;    /* fmcomp data (.fmd) */
	}

    strncpy( (char*)p , (char*)p2 , strlen( (char*)p2) );  /* filenameA(ŃtpX) */
    *(p+strlen( (char*)p2)+1) = '\0';  /*oO*/

	if(f_fmcomp == 0)  /* ==0 MIDI */
	{
		printf("midiname : ");
	}
	else
	{
		printf("fmcomp : ");
	}
	printf("%s\n",fmdname);

/*=-------------------------------------*/
    /*ȍ~  exit֐ŔoĂ͂ȂȂ*/
    /*exit֐gpꍇ͊mۂ邱*/

    /*i[pm <20010120p>======*/
    f_mcwrkerr=FALSE; /*擾Ɏs true */
    for(mcwrk=0;mcwrk< MAX_CH;mcwrk++)
    {
        if ((chxmem[mcwrk] =(unsigned char*) malloc(CH_MEMMAX+1)) ==NULL)
        {
            f_mcwrkerr=TRUE; /* out of memory */
            break;  /* for break out */
        }
    }
    /*  */
    if(f_mcwrkerr==TRUE)
    {
        for(i=0;i< (mcwrk+1);i++)
        {   free(chxmem[i]);}
        printf("out of memory\n");
        return 1;  /* out of memory return */
    }
    /*==================================*/

    /* source1name = argv[1]; */
    source1name = c1;  /* source */
	#if 0  /* debug */
	printf("c1 : [%s]\n",c1);
	#endif

    if(opensource1(source1name) < 0)
    {
        f_lineloop = 0;  /*[vȂ*/
        printf("Can not open source file!\n");
        ext_err=1;  /*err*/
    }
	else
	{
		f_rdopen = 1;  /* openł v1.01.02 */
	}
	/*=======================================*/

    while(f_lineloop)
    {
        rdcnt = rd1line();
        rdworkptr=rdwork;  /* reset */
        while(1)
        {
            if(rdcnt <= 0){f_lineloop=0;break;}

            execd = chkexec();

			/* debug */
			/* printf("execd:%d\n",execd); */

			/* ߃R[hɂ镪 */
            switch(execd)
            {
                case 0: break;
                case 1: chopen=chval;break;
                case 2: open_ch(chopen);break;
                case 3: ext_err = cdecnv();break;
                case 4: close_ch();break;
                case 5: break;  /*<20010126a>  RgJn*/
                case 6: break;  /*<20010126a>  RgI*/
                case 7: ext_err = option_set();break; /* <20010914p> */
                case 8: ext_err = copyr_set();break; /* <20011231a> */
                case 9: ext_err = sname_set();break; /* <20020114p> */
                case -1: ext_err = 1;break;
                default: printf("op code err\n");ext_err = 1;break;
            }
            if(ext_err != 0)
            {
                printf("line (%ld) : %s\n",rd_linecount,rdwork);
                out_exterr(ext_err);

                f_lineloop = 0;  /*loop stop*/
                break;
            }

            if(execd== 0)break;
        }
/*        if(rdcnt <= 0)break; */
    }

	if( f_rdopen == 0 ) /* rev v1.01.02  20171031p */
	{
		/* JĂȂ̂ŉȂ */
	}
	else
	{
		/* 鏈s */
	    closesource1();
	}
	
    if(ext_err != 0)
    {
        printf("compile stopped!\n");
    }
    else
    {

        fbin_hand = openfmbin();

        if(fbin_hand < 0)
        {
            printf("fmbin open err\n");
            ext_err = 1;
        }
        else
        {
			if(f_fmcomp == 0)
			{
				ext_err = wrtfmbin();  /* SMF */
			}
			else
			{
				ext_err = wrtfmcomp(); /* fmcompdata */
			}

           	if(ext_err == 0)
           	{
           	    ext_err = closefmbin();
           	}
           	else             /*<20010127p>*/
           	{
           	    out_exterr(ext_err); /*<20010127p>*/
               	closefmbin();  /*close*/
               	ext_err = 1;  /*<20010127p>*/
           	}
		}
    }

	/* v1.01.00 <20170919p> */
	if(f_fmcomp >= 1)  /* >=1 ̂Ƃfmcompf[^o͂̂ */
	{
		/* Track LengthvZē(SMFo͎͂łɓĂ̂ŕsv) */
		/* fmcompf[^ô͎0ɂȂĂ̂ōČvZ */
		for(i=0;i< MAX_CH;i++)
		{
			if(chxcnt[i]>0)
			{
				chxcntwork = chxcnt[i];  /* ch̊i[oCg擾 */
				p = chxmem[i];       /* Y`l̃f[^i[ꏊ擾 */
				chxlenwork=0;

				for(j=0;j< chxcntwork;j+=2)
				{
					/*  096܂ł͉, 255͏IR[h */
					/* +0ɉE@\ԍA+1ɒEl    */
					if( p[j] <= 96 ) { chxlenwork += p[(j+1)]; }
					if( p[j] == 255 ) { break;}   /* break */
				}
				chxlen[i]=chxlenwork; /* i[ */
			}
		}
	}
	/* ------------- */

    if(ext_err == 0)
    {
		for(i=0;i< MAX_CH;i++)
        {
        	if(chxcnt[i]>0)
            {
				/* RpCTCY\*/
				/*rev<20010127p><20171004a>*/
				/* *15͎l(fmc 32)15{(32*15 = 480) */
                printf(" -> ch%d  size(%ld byte)  ",i+1,chxcnt[i]);
				if(f_fmcomp == 0)
				{
					printf("Track Tick (%ld)\n",(chxlen[i]*15) );
				}
				else   /* fmcomp data */
				{
					printf("fmc Length (%ld)\n", chxlen[i] );
				}
			}
        }
        printf(" ** complete! **\n");
    }
    else
    {
        /* printf("compile stopped!\n"); */
    }

    /*==========================*/
	/* ̏ԕ\ */
    /* debugdebugdebug */
	/* p = chxmem[0];*/ /* ch1 */
	/* printf("chxcnt[0]:%d\n",chxcnt[0]);*/
	/*
	for(i=0;i<chxcnt[0];i++,p++) 
	{
		printf("%x ",(unsigned char)*p);
	}
	*/
    /* ̉ */
    /*  */
    for(i=0;i< MAX_CH;i++)
    {   free(chxmem[i]);}

    return ext_err;
}
/* ------------------------- */
/* v1.01.00 20171004p        */
/* fmcomp data output        */
/* ------------------------- */
int wrtfmcomp()
{
	int i,c,ret_val;
	unsigned short w1,w2;

#define FMCHEDSIZ 16
	char fmched[ (FMCHEDSIZ+1)] = "FMP000FMC001\x20\x00\x10\x00";
#define CHXOFSSIZ 32
	unsigned short chxofs[ ( (CHXOFSSIZ+1)/2 )];  /* 32byte / 2 = 16WORD */

	unsigned char fmcendcod [(2+1)] = { 0xff,0xff };

	for(i=0; i< (CHXOFSSIZ/2) ;i++) /* oCg[hɂ邽/2 */
	{
		chxofs[i] = '\0';  /* reset */
	}

	w1 = 0x20;   /* f[^i[JnԒn */

	/* v1.01.01 ch1ȂƂ̃oOC 20171025p */
	for(i=0; i< MAX_CH;i++)
	{
		w2 = (unsigned short)chxcnt[i];
		if(w2 != 0)  /* gƂ̂ */
		{
			chxofs[i]= w1; /* ̂Ŋi[ */
			w1 += w2;	/* ̏(Ίi[Ȃ) */
			w1 += 2;    /* endR[hǉ(0xff 0xff2byte) */
		}
	}

    /* midi comp32 */
    c = 0; /* o͂gbN */
    /* <20010127p> */
    ret_val=0; /* G[ԍ */

    for(i=0;i<MAX_CH;i++)
    {
        if(chxcnt[i] > 0) { c++; }
    }
    if(c == 0){ return 0;} /* ret */

	/* fmcomp ʏo */
	fwrite(fmched,1,FMCHEDSIZ,wr_hand);

	/* fmcomp ofso */
	fwrite(chxofs,1,CHXOFSSIZ,wr_hand);

	/* e`lo */
    for(i=0;i< MAX_CH;i++)
   	{
   	    if(chxcnt[i] > 0)
        {
			/* `lf[^o */
			fwrite(chxmem[i],1,chxcnt[i],wr_hand); /* wb_TCY14byteŒ */
			/* ŌɏIR[h */
			fwrite(fmcendcod,1,2,wr_hand); /* endcode2byteŒ */
        }
    }
    return ret_val;  /* <20010127p>*/
}
/* ------------------------ */
int opensource1(char *sourcename)
{
	if(( rd_hand = fopen(sourcename,"rb"))==NULL)
	{	return -1;}
	else
	{	printf("sourcename:%s\n",sourcename);
        f_rd_open = 1;  /*ʏɓǂݏł(1)ɂ*/
	}
	return 0;
}
/*-------------------*/
int rd1line()
{
	char *p;
	int f_rd;
	int c=0;

    p= rdwork;   /*work area addr*/
    *p = 0;   /*Ԃ͂߂(듮h~)*/

	/*printf("p:%d\n",p);*/

	while(1)  /* LF(CRLF)łȂƂ͓ǂݍ*/
	{
		f_rd = fread(p,1,1,rd_hand);   /*1byte read*/
		if(f_rd == 0){ /*c=0;*/  *p = 0x0d;p++; break; } /*ԍŌ̍srŏIƂ̂*/
		if(*p == 0x0a || *p == 0x1a){break; }  /* <20010117p> */
    	p++;  /*i[ꏊ*/
		c++;  /*counter up.*/
		if(c > (LINEMAX-1))
        {
        	printf("work area over!\n");
	        return (-1);  /*error*/
        }
    }
	*p = 0;
/*====================
//
//ǂݍ񂾍sinc
*/
	if(rd_linecount < MAXLINECNT)  /* <20010115a> */
	{
	    rd_linecount++;
	}
	else
	{
		printf( "**** line over(MAX:%ld line) ****\n"
				"**** compile stopped. ****\n",MAXLINECNT);
		return (-1); /* error */
	}

/*debug*/
/*	printf("rd : %s\n",rdwork);*/

	return (c); /*no error*/
}

int closesource1()
{
    /*printf("closesource1\n");*/
    fclose(rd_hand);
    return 0;  /*debugclose*/
}

int openfmbin()
{
    /*printf("openfmbin\n");*/
    if ((wr_hand = fopen(fmdname,"wb"))==NULL)
    {	return -1;}
    return 0;
}

/* =============================================== */
/* mdcomp v0.00.02 <20010117p> */
void MidHedOut(unsigned short midformat,unsigned short trackval,unsigned short onpu4)
{
	unsigned char midwrtwork[16]; /* midi hed work */
	unsigned char *p;
	unsigned short *p_s;
	unsigned char a; /* work */

	p=midwrtwork;
	p[0]='M'; p[1]='T'; p[2]='h'; p[3]='d';
	p[4]=0; p[5]=0; p[6]=0; p[7]=6;

	p_s = (unsigned short*)(p+8); /* format store addr */
	*p_s = midformat;
	a = p[9]; p[9]=p[8]; p[8]=a;  /* gGfBA */

	p_s = (unsigned short*)(p+10); /* gbN̐ */

	/* bug v1.01.00 (20170908) */
	trackval++;  /* R_N^[gbNǉ */
	*p_s = trackval;

	a = p[11]; p[11]=p[10]; p[10]=a;  /* gGfBA */

	p_s = (unsigned short*)(p+12); /* l̒ */
	*p_s = onpu4;
	a = p[13]; p[13]=p[12]; p[12]=a;  /* gGfBA */

	/* midi hedt@Cɏo */
	fwrite(midwrtwork,1,14,wr_hand); /* wb_TCY14byteŒ */
}

/* =============================================== */
/* mdcomp v0.00.02 <20010116p> */
int wrtfmbin()
{
	int i,c,ret_val;  /* midi comp (dos) <20010628>*/

    /* midi comp32 */
    c = 0; /* o͂gbN */
    /* <20010127p> */
    ret_val=0; /* G[ԍ */

    for(i=0;i<MAX_CH;i++)
    {
        if(chxcnt[i] > 0) c++;
    }

    if(c == 0)return 0; /* ret */

	/* SMFɂ͕KKv */
	MidHedOut(1,(unsigned short)c ,O4BK);   /* MidHedOut(format,track,onpu4) */
	MidTrackOutConductor();  /* v1.01.00 (20171003p) */

    for(i=0;i< MAX_CH;i++)
   	{
   	    if(chxcnt[i] > 0)
        {
       	    /* rev<20010127p> MidTrackOut(炷ch, addr ,count) */
   	    	ret_val=MidTrackOut(i+1,chxmem[i],chxcnt[i]);
        }

		if(ret_val != 0) { break; }  /* rev<20010315p> */
    }
    return ret_val;  /* <20010127p>*/
}
/* ============================ */
/* and֐(߂l͉Z钷)<20010127p>*/
int len_and(unsigned char *ch_addr,long ch_count,long *i)
{
    int ret_len=0;  /*߂̒i[p*/
    int j;  /*p*/

    j=(*i)+2;

    while(ch_count>=(j+3))
    {
        if(ch_addr[j]== 251)
        {
            ret_len+=ch_addr[j+3];  /* 251,0̎ɂ閽߂̒*/
	    (*i)+=4;  /* Ƃi251,0̎*/
            j+=4;  /* 251,0ô*/
        }
        else
        {
            break; /* 251ȊÔƂwhile𔲂o */
        }
    }

    return ret_len;
}
/* ----------------------------------------- */

void MidTrackOutConductor()
{
	/*gbN0ԂƂďo*/
#define MIDWRTWORKSIZ 100
	unsigned char midwrtwork[MIDWRTWORKSIZ];  /* ޑÖꎞstack */
	unsigned char *p;
	unsigned long *p_l; /* work */
	unsigned char a; /* work */

	long midfilepos;  /* t@C|C^̈ʒui[p */
	unsigned long trackcount;  /* track count */

/* Cdl̏C */
	int d_time_work;
	int i;
	int j;

	/* f[^̏ */
	/* ݂̃t@C|C^ʒuL^ */
	midfilepos = ftell(wr_hand);

	/* gbNJn錾 */
	p= midwrtwork;
	p[0]='M'; p[1]='T'; p[2]='r'; p[3]='k'; /* gbNJn錾 */
	p[4]=0xff;p[5]=0xff;p[6]=0xff;p[7]=0xff; /* TCYsmȂ̂ōől */
	p[8]=0; /* gbNTCY̎̂͒P */
	fwrite(midwrtwork,1,9,wr_hand);  /* 9byte write */

	/*f[^output */

	trackcount = 1;  /* ł1byteݍς݂̂ 1 Jn */

	/* <20011231p> v0.00.09  cr@\ ------ */
	/* 쌠\񏑂o */
	if(f_copyr_sw == TRUE) /* 쌠o true=o */
	{
		p = midwrtwork;
		p[0]=0xff;
		p[1]=0x02;
		p[2]=(unsigned char)copyr_len; /* 쌠̒ */
		fwrite(midwrtwork,1,3,wr_hand); /* 3 byte wrt */
		trackcount += 3;  /* size */
		fwrite(copyr_work,1,copyr_len,wr_hand); /* copyr_len byte wrt */
		trackcount += copyr_len; /* wrt size add */
		p[0]=0;
		fwrite(midwrtwork,1,1,wr_hand); /* tick count */
		trackcount += 1;  /* size */
	}

	/* ----------------------------------- */
	/* <20020114p> v0.00.10  sn@\ ------ */
	/* V[PXo */
	if(f_sname_sw == TRUE) /* V[PXo true=o */
	{
		p = midwrtwork;
		p[0]=0xff;
		p[1]=0x03;    /* 03  sname */
		p[2]=(unsigned char)sname_len; /* V[PX̒ */
		fwrite(midwrtwork,1,3,wr_hand); /* 3 byte wrt */
		trackcount += 3;  /* size */
		fwrite(sname_work,1,sname_len,wr_hand); /* sname_len byte wrt */
		trackcount += sname_len; /* wrt size add */
		p[0]=0;
		fwrite(midwrtwork,1,1,wr_hand); /* tick count */
		trackcount += 1;  /* size */
	}
	/* ----------------------------------- */

	/* <20170908a> v1.01.00 @\ǉ ==== */
	/* 8/1ɂƂ */
	p = midwrtwork;  /* ꎞf[^i[GA */
	p[0]=0xff;    /* */
	p[1]=0x58;    /* */
	p[2]=0x04;    /* */
	p[3]=0x01;    /* 1 */
	p[4]=0x03;    /* 0x02=4,0x03=8  (8/1) */
	p[5]=0x18;    /* */
	p[6]=0x08;    /* */
	p[7]=0x81;    /* x点鎞(240) */
	p[8]=0x70;    /*  */
	fwrite(midwrtwork,1,9,wr_hand);  /* 9 byte wrt */
	trackcount += 9;  /*  end size */
	/* ===================================== */

	/* l̃e|Ƃ120 */
	trackcount += midtmpwrt(TEMPO);

	/* <20170908a> v1.01.00 @\ǉ ==== */
	/* 4/4ɂƂ */
	p = midwrtwork;  /* ꎞf[^i[GA */
	p[0]=0xff;    /* */
	p[1]=0x58;    /* */
	p[2]=0x04;    /* */
	p[3]=0x04;    /*1 */
	p[4]=0x02;    /* 0x02=4,0x03=8  (8/1) */
	p[5]=0x18;    /* */
	p[6]=0x08;    /* */
	p[7]=0x00;    /* x点鎞 */
	fwrite(midwrtwork,1,8,wr_hand);  /* 8 byte wrt */
	trackcount += 8;  /*  end size */
	/* ===================================== */

	/* e`lɏoTEMPÕgbNɏo͂ */
	/* v1.01 <20170923a> */
	/* oO */

	for(i=0;i< MAX_CH;i++)
	{
		/* e`lJn */
		d_time_work = 0;   /* f^timƂ(e|߂oĂƂ̊) */

		if(chxcnt[i] > 0)
		{
			p = chxmem[i];
			for(j=0;j < (signed)chxcnt[i];j+=2)
			{
				if(p[j] <= 96)  /* fB̎擾 */
            	{
					int n;
					n = (int)p[(j+1)];
					d_time_work += (O4BK / FMO4) * n;  /*  (480 / 32) *n */
				}

				if(p[j] == 252)  /* tempo 252 */
				{
					/* ܂łd_time_worko͂Ă(o͂̓Rg) */
					unsigned char *p2;
					unsigned long c;
					unsigned char a;

					p2 = midwrtwork;  /* ꎞf[^i[GA */
					p2[0]=0xff;    /* */
					p2[1]=0x01;    /* text */
					p2[2]=0x01;    /* 1  */
					p2[3]='_';     /* _ */
					p2[4]=0x0;    /* x点鎞 ɓƂ */
					p2[5]=0x0;    /* */
					c = midlencnv( &p2[4], (MIDWRTWORKSIZ-4) , d_time_work);
					c += 4;  /* ł4oCĝŉZ */
					trackcount += c;  /*  end size */
					fwrite(midwrtwork,1, c ,wr_hand);  /* c byte wrt */
					d_time_work = 0; /* 񂾂̂ŏ */

					a = p[(j+1)];
					trackcount += midtmpwrt(a);
				}
			}
		}
	}
	/* ------------------------ */
	/* ׂĂ̏o͂͂܂łŏIĂ */
	/* ̉ŏIƃTCYނ */
   /* Ïo */

	p = midwrtwork;  /* ꎞf[^i[GA */
	p[0]=0xff;p[1]=0x2f;p[2]=0; /* end track */
	fwrite(midwrtwork,1,3,wr_hand);  /* 3 byte wrt */
	trackcount += 3;  /*  end size */

	/* t@C|C^obNAbvƂɖ߂ */
	fseek(wr_hand,midfilepos,SEEK_SET);
	/* 񂾃gbNMTrk'M'܂Ŗ߂ */

	/* Tracksize܂ŃV[N */
	fseek(wr_hand,4L,SEEK_CUR);

	p_l = (unsigned long*)midwrtwork;
	*p_l = trackcount;  /* trackcounti[ */

	a = p[3]; p[3]=p[0]; p[0]=a;  /* 3 xchg 0 */
	a = p[1]; p[1]=p[2]; p[2]=a;  /* 2 xchg 1 */
	fwrite(midwrtwork,1,4,wr_hand);  /* 4 byte wrt */

	fseek(wr_hand,0L,SEEK_END); /* file end ܂ňړ */
   /* ===================================== */
}
/* =========================================== */
/* mdcomp v0.00.02 <20010116p> */
int MidTrackOut(int ch_run,unsigned char *ch_addr,long ch_count)
{
	long i;  /* for next */
/*	unsigned char cde_len; */ /* cde length */
	unsigned long cde_len; /*cde length rev<20010322p> */
	unsigned char cde;  /* onkai */
	int wrt_volume;  /* volume default <20010115p> */
	unsigned char midwrtwork[100];  /* ޑÖꎞstack */
	unsigned char *p;
	unsigned long *p_l; /* work */
	unsigned char a;  /* work */
	long *ix;  /* work <20010627p> v0.00.05 */

	long midfilepos;  /* t@C|C^̈ʒui[p */
	unsigned long trackcount;  /* track count */
	int f_startcde = 0; /* 0x9?R[hgptO 0==,0<>) */

	/* Turbo C <20171003> */
	unsigned char bch;  /* v1.01.00 (20170906)oO */

	/*̓oOȂ̂ŒKv(<20010321p>)*/
/*	static int f_storetmp = 0;*/ /* e|xނ */

	/*ch_run_exiOϐjɌݏݒch <20010321p>*/
    ch_run_ex = ch_run;   /* ( 1`9܂ł̐l ) */


	/* f[^̏ */
	/* ݂̃t@C|C^ʒuL^ */
	midfilepos = ftell(wr_hand);

	/* gbNJn錾 */
	p= midwrtwork;
	p[0]='M'; p[1]='T'; p[2]='r'; p[3]='k'; /* gbNJn錾 */
	p[4]=0xff;p[5]=0xff;p[6]=0xff;p[7]=0xff; /* TCYsmȂ̂ōől */
	p[8]=0; /* gbNTCY̎̂͒P */
	fwrite(midwrtwork,1,9,wr_hand);  /* 9byte write */

	/*f[^output */

	trackcount = 1;  /* ł1byteݍς݂̂ 1 Jn */
	wrt_volume = 10; /* <20010115p> default */

	/* VXeplo (PTrack̂) */
	if(f_storetmp == 0)
	{
        /* <20010309p> v0.00.04a @\ǉ ====*/
        /*GM system on*/
        p = midwrtwork;  /*ꎞf[^i[GA*/
    	p[0]=0xf0;    /*GNXN[VuEXe[^X*/
        p[1]=0x05;    /*byte(TCY)*/
        p[2]=0x7e;    /*IDio[(ް٥رѥү)*/
        p[3]=0x7f;    /*foCXID(Broadcast)*/
        p[4]=0x09;    /*TuID#1(General MIDi Message)*/
        p[5]=0x01;    /*TuID#2(General MIDI On)*/
        p[6]=0xf7;    /*EOX(ޥޥٰ)*/
        p[7]=0x81;    /*x点鎞(50msȏ) v1.01 tick 0.5/480tick) */
        p[8]=0x10;    /*x点鎞(144) */
    	fwrite(midwrtwork,1,9,wr_hand);  /* 9 byte wrt */
    	trackcount += 9;  /*  end size */
        /*=====================================*/
		f_storetmp = 1; /* li[ς */
	}
    else /* lX^[gx点 */
    {
		/* 2trackȍ~̓RgĎԒ */
		p = midwrtwork;  /* ꎞf[^i[GA */
		p[0]=0xff;    /* */
		p[1]=0x01;    /* text */
		p[2]=0x01;    /* 1  */
		p[3]='_';     /* _ */
		p[4]=0x81;    /* x点鎞(144) */
		p[5]=0x10;    /*  */
		fwrite(midwrtwork,1,6,wr_hand);  /* 6 byte wrt */
		trackcount += 6;  /*  end size */

    }

	/* <20010309p> v0.00.04a @\ǉ======== */
	p = midwrtwork;  /* ꎞf[^i[GA */
	bch = (unsigned char)ch_run; /* ݒ̃`l */
	bch = bch & 0x0f;  /* 0}XN */
	bch = bch | 0xb0;  /* 0xb0 or */
	p[0]=bch;    /* I[TEhIt */
	p[1]=0x78;
	p[2]=0x00;
	p[3]=0x60;    /* x点鎞 (96) */
	fwrite(midwrtwork,1,4,wr_hand);  /* 4 byte wrt */
	trackcount += 4;  /*  end size */
	/* ======================================= */

	/* yƂăsAm */
	if(ch_run != 9)
	{
    	/* Y`lȊO̓sAmw */
		trackcount += midmelwrt((unsigned char)ch_run,0); /* (ch,len) */
	}

    /*Ez̎Panpot`lƂɓ*/
    /*v0.00.07 <20010906p>--*/
    if(ch_run >= 2 && ch_run <= 7 && f_auto_lr==TRUE)
    {
        int autopanpot = PAN_DEF; /*panpot */
        switch(ch_run)
        {
            case 2: autopanpot = MIN_PAN;break;
            case 3: autopanpot = MAX_PAN;break;
            case 4: autopanpot = PAN_DEF/3;break;
            case 5: autopanpot = PAN_DEF/3+PAN_DEF;break;
            case 6: autopanpot = PAN_DEF/3*2; break;
            case 7: autopanpot = PAN_DEF/3*2+PAN_DEF;break;
        }
        trackcount += midpanwrt((unsigned char)ch_run,autopanpot);
    }
    /*---------------------*/

	for(i=0;i<ch_count;i+=2)
	{
		cde = ch_addr[i];
		cde_len = ch_addr[i+1];
		if(cde <= 96 && cde != 0)
		{
			if(f_startcde == 0) /* ߖgp */
			{
				a = (unsigned char)(ch_run & 0x0f);
				a = (unsigned char)a | (unsigned char)0x90;  /* mask */
				p[0] = a; /* store */
				fwrite(midwrtwork,1,1,wr_hand); /* 1 byte write */
				trackcount++;  /* 1byte */
				f_startcde = 1;  /* gpς݂ɕύX */
			}

		    ix = &i;  /* C bug <20010627p> v0.00.05 */

		/* printf("i 1: %d\n",i); */
	    cde_len+=(unsigned long)len_and(ch_addr,ch_count,ix); /* <20010127p>and֐*/
		/* printf("i 2: %d\n",i); */

	    chxlen[ch_run-1]+=cde_len;  /* <20010127p>Si[ */
		/* printf("cde_len :%d\n",cde_len); 
		printf("chxlen : %d\n",chxlen[ch_run-1]); */
			/* debug */
	    /*Memo2->Lines->Add("cde_len:"+IntToStr(cde_len));*/ /* <20010628a>oO */
			trackcount += midcdewrt(cde,wrt_volume,cde_len);
		}
		else if(cde == 255)
		{
			break;
		}
		else if(cde == 254) /* melody change */
        {
			trackcount += midmelwrt(ch_run,cde_len); /* (ch,len) */
			f_startcde = 0;  /* gpɕύX */
		}
		else if(cde == 253) /* volume <20010115p> */
		{
			wrt_volume = cde_len;  /* volume set <20010115p> */
			if(wrt_volume > MAX_VOLUME) wrt_volume = MAX_VOLUME;
		}
		else if(cde == 252) /* tempo <20010115p> */
		{
			/*printf("tempo:%d\n",cde_len);*/
			trackcount += midtmpwrt(cde_len);
		}
        else if(cde == 251) /* and <20010127p> */
        {
            /*debug*/
	    printf("[error] &  single(ch%d)",ch_run);

            return 11;  /* error (ʊ֐邽߂ŏo͂Ȃ)*/
        }
		else if(cde == 250) /* q value<20010321p>v0.00.05 */
		{
			/*zɂĂ̂͏듮h~邽*/
			q_ch[ch_run-1]=cde_len;  /* q value backup v0.00.05 */
/*			trackcount += midtmpwrt(cde_len);*/
		}
		else if(cde == 249) /* panpot<20010830p>v0.00.06 */
		{
			trackcount += midpanwrt(ch_run,cde_len); /*(ch,len)*/
			f_startcde = 0;  /* gpɕύX(ȂƑɉł) */
		}
		else if(cde == 0) /* x */
		{
			if(f_startcde == 0) /* ߖgp */
			{
				a = (unsigned char)(ch_run & 0x0f);
				a = (unsigned char)a | (unsigned char)0x90;  /* mask */
				p[0] = a; /* store */
				fwrite(midwrtwork,1,1,wr_hand); /* 1 byte write */
				trackcount++;  /* 1byte */
				f_startcde = 1;  /* gpς݂ɕύX */
			}
            chxlen[ch_run-1]+=cde_len;  /* <20010127p>Si[ */
			trackcount += midcdewrt( 0 , 0 , cde_len);  /*  ԍ 0  0 */
		}
	}
   /*܂*/

   /* Ïo */

	p[0]=0xff;p[1]=0x2f;p[2]=0; /* end track */
	fwrite(midwrtwork,1,3,wr_hand);  /* 3 byte wrt */
	trackcount += 3;  /*  end size */

	/* t@C|C^obNAbvƂɖ߂ */
	fseek(wr_hand,midfilepos,SEEK_SET);
	/* 񂾃gbNMTrk'M'܂Ŗ߂ */

	/* Tracksize܂ŃV[N */
	fseek(wr_hand,4L,SEEK_CUR);

	p_l = (unsigned long*)midwrtwork;
	*p_l = trackcount;  /* trackcounti[ */

	a = p[3]; p[3]=p[0]; p[0]=a;  /* 3 xchg 0 */
	a = p[1]; p[1]=p[2]; p[2]=a;  /* 2 xchg 1 */
	fwrite(midwrtwork,1,4,wr_hand);  /* 4 byte wrt */

	fseek(wr_hand,0L,SEEK_END); /* file end ܂ňړ */
   /* ===================================== */
    return 0;
}
/* ------------------- */
/* v1.01.00 (20171003) */
unsigned long midlencnv(unsigned char *w_p,int wpmax,long m_len)
{
	unsigned int a8work;  /*<20010127p> */
	unsigned int b4,b3,b2,b1;
	unsigned long c;
	c=0;

	if(wpmax <= 4) { return c;}  /* 4byteȏw_pƂ */
/* b4=0;b3=0;b2=0;b1=0; */

	a8work = (unsigned long)m_len;

	b2 = (a8work >> 7);
	b3 = (a8work >> 14);
	b4 = (a8work >> 21);

	b1 = a8work & 0x7f;
	b2 = b2 & 0x7f;
	b3 = b3 & 0x7f;
	b4 = b4 & 0x7f;

	if(b4 != 0) { b4 |= 0x80; w_p[c]=(unsigned char)b4;c++;}
	if(b3 != 0) { b3 |= 0x80; w_p[c]=(unsigned char)b3;c++;}
	if(b2 != 0) { b2 |= 0x80; w_p[c]=(unsigned char)b2;c++;}
	w_p[c]=(unsigned char)b1;c++;

	return c;
}
/* ============================================== */
/* h~ */
unsigned long midcdewrt(unsigned char m_key,int m_vol,int m_len)
{
#define W_PMAX 10
	unsigned char w_p[W_PMAX]; /* work area */
	unsigned long c=0; /* work */

	unsigned char q_adjust;  /* <20010321p> v0.00.05 (Cp)*/
	unsigned char q_len;     /* <20010321p> v0.00.05 (炷) */

	/* m_key+MID_ADJUSTƂĂ̂fmcompƂ̂˂ */
	w_p[c] = (unsigned char)((unsigned char)m_key+MID_ADJUST);
	 c++;
	w_p[c] = (unsigned char)t_volume[m_vol]; c++;

	/* m_len͎l32ƂČvZĂ̂ */
	/* l480ƂȂ悤ɌvZ v1.01.00 (2017/09/06) */
	m_len = m_len * (O4BK / 32);

	/* debug */
	/* printf("===== midcdewrt start=====\n");*/

    /*rev<20010127p>*/
/*	if(m_len >= 128 && m_len <= 16384-1) */
	if(m_len >= 128)
	{
		/* midlencnv(WORKADDR,WORKMAXSIZE,l) ߂l͏݃oCg */
		c += midlencnv(&w_p[c],(W_PMAX-c),m_len);
#if 0   /* old source */
        int a8work;  /*<20010127p>*/
        a8work = m_len;
        a8work = a8work >> 7; /* 7bit R<20010127p>*/
        a8work = a8work & 0x07f;  /* 7bit mask<20010127p> */
        a8work = a8work | 0x80;   /* bit7 on<20010127p> */
		w_p[c] = (unsigned char)a8work; c++; /* rev<20010127p> */
		w_p[c] = (unsigned char)(m_len & 0x7f); c++; /* rev<20010322p> */
#endif
        /* debug<20010127p> */
        /* Memo2->Lines->Add("m_len(128<=x):"+IntToStr(m_len)+",a8work:"+IntToHex(a8work,4)); */
		/* Memo2->Lines->Add("m_len(128<=x):"+IntToStr(m_len)+",(0x7f):"+IntToHex(m_len&0x7f,4)); */
		w_p[c] =(unsigned char)(m_key+MID_ADJUST); c++;
	   	w_p[c] = 0; c++;  /* volume 0 (Ď̉ɑΉ)*/
		w_p[c] = 0; c++;  /* len 0 (̖߂܂ł̎) original*/
	}
	else
	{
/*		w_p[c] = (unsigned char)m_len; c++; */ /* original */

		/*xȂ邪Č߂邽߂ɓ*/
		float work_m_len;
        work_m_len = (m_len/8.0) * ((q_ch[ch_run_ex-1])+1); /* rev */
		q_len = (unsigned char)work_m_len; /* convert */

		/* A듮삷̂ */
		if(q_len==0 && m_len >= 1) /* rev<20010830p> v0.00.06 */
		{
        		q_len = 1;  /*<20010321p>炷͍ŒP*/
		}

		w_p[c] = q_len; c++;  /* rev<20010321p> v0.00.05 */

		/* debug */
		/* printf("mkey+ADJ:%d\n",m_key+MID_ADJUST);*/
		w_p[c] =(unsigned char)(m_key+MID_ADJUST);
		/* printf("w_p[c]:%d\n",w_p[c]); */
		 c++;


	   	w_p[c] = 0; c++;  /* volume 0 (Ď̉ɑΉ)*/
		q_adjust =(m_len-q_len);  /* C <20010321p> */
		w_p[c] = q_adjust; c++;  /* (̖߂܂ł̎) rev<20010321p>*/

        /* debug */
        /* printf("%d:%d=%d+%d\n",ch_run_ex,m_len,q_adjust,q_len); */

	}

	fwrite(w_p,1,c,wr_hand);  /* c byte wrt */

	 /* printf("write c :%d\n",c);*/
	return (c);  /* write count return */
}
/* ============================================== */
/* yԍύX */
unsigned long midmelwrt(unsigned char m_ch,int m_len)
{
	unsigned char w_p[10]; /* work area */
	unsigned long c;  /* write count */
	unsigned char a; /* work */

	a =(unsigned char)(m_ch & 0x0f); /* mask */
	a =(unsigned char)( a | 0xc0);   /* or mask */
/*	a = m_ch & 0x0f;*/ /* mask */
/*	a = a | 0xc0; */  /* or mask */

    if(m_len > MAXGAKKI)
    {
        m_len = 0; /* over flow reset */
    }

	c=0; /* reset */
	w_p[c] = a;  c++; /* melody chenge */
	w_p[c] = (unsigned char)m_len; c++;  /* melody no. */
	w_p[c] = 0; c++; /* tick */

	fwrite(w_p,1,c,wr_hand);  /* c byte wrt */
	return (c);
}
/* ============================================== */
/* tempo */
unsigned long midtmpwrt(int m_len)
{
	unsigned char w_p[10]; /* work area */
	unsigned long c;  /* write count */
	unsigned char a; /* work */
	double b; /* work */
	unsigned long msec4; /* work */
	unsigned long *p_l; /* work */
	unsigned char *p;

	b = 60.0 / m_len * 1000000; /* micro sec */
	msec4 = (unsigned long)b; /* convert */

	c=0; /* reset */
	w_p[c] = 0xff; c++;
	w_p[c] = 0x51; c++;
	w_p[c] = 0x03; c++;

	p_l = (unsigned long*)(w_p+c);
	p = (unsigned char*)p_l;

	*p_l = msec4;  /* tempo store */

	a = p[3]; p[3]=p[0]; p[0]=a;  /* 3 xchg 0 */
	a = p[1]; p[1]=p[2]; p[2]=a;  /* 2 xchg 1 */

	p[0] = p[1];
	p[1] = p[2];
	p[2] = p[3];  /* 24 bit data */

	c += 3;

	w_p[c] = 0;  /* PZbg̏I */
	c++;

	fwrite(w_p,1,c,wr_hand);  /* c byte wrt */
	return (c);
}
/* ===================================================== */
/* ============================================== */
/* Panpot(̏o͕)<20010830p>v0.00.06 */
/* ============================================== */
unsigned long midpanwrt(unsigned char m_ch,int m_len)
{
	unsigned char w_p[10]; /* work area */
	unsigned long c;  /* write count */
	unsigned char a; /* work */

	a =(unsigned char)(m_ch & 0x0f); /* mask */
	a =(unsigned char)( a | 0xb0);   /* or mask() */

	if(m_len > MAX_PAN)
	{
		m_len = PAN_DEF; /* over flow reset */
	}

	c=0; /* reset */
	w_p[c] = a;  c++; /* panpot */
	w_p[c] = 0x0a;c++; /* panpot */
	w_p[c] = (unsigned char)m_len; c++;  /* panpot̒l */
	w_p[c] = 0; c++; /* tick */

	fwrite(w_p,1,c,wr_hand);  /* c byte wrt */
	return (c);
}
/* ============================================== */

int closefmbin()
{
    fclose(wr_hand);
    return 0;
}

int chkexec()
{
    int f_chkloop=1; /* 1==loop,0==loopout */
    int retcode = -1;  /*߂li[*/
	int i;  /* for */
    int exe_sw;

    /* codenameɒǉꍇ ߃R[h ύX邱 */
    /*rev<20010907p><20011231p><20020215p>*/
    char *codename[EXECMAX] = {"//","ch","{","\"","}","/*","*/","op","cr","sn"};

/*    printf("chkexec:");printf(rdworkptr);printf("\n");
//    printf("original: %d\n",rdworkptr);
*/
    while(f_chkloop)
    {
        switch(*rdworkptr)
        {
            case ' ': rdworkptr++;break;
            case 0x09:rdworkptr++;break;
            default : f_chkloop = 0;
        }

		/* debug */
		#if 0
		printf("%d : %d\n",rdworkptr,(rdwork+LINEMAX));
		#endif

        if(rdworkptr >= (rdwork+LINEMAX)) f_chkloop = 0;
    }

    f_chkloop = 1;  /*for̔op(1==loop)*/
    for(i=0;i<EXECMAX;i++)
    {

        exe_sw=strncmp((char *)rdworkptr,codename[i],strlen(codename[i]));
/*        exe_sw=strncmp(rdworkptr,codename[i],strlen(codename[i]));*/

        if(exe_sw == 0)
        {
            rdworkptr+=strlen(codename[i]); /*̈ʒuptrړ*/
            /*printf("strlen:%d ",strlen(codename[i]));*/

	    /*rev<20010126a>*/
	    if(f_remskip==FALSE && i != 6)
            {
                /* dv ߃R[h */
                switch(i) /*߃R[hɑ΂switch*/
                {
                    case 0: retcode = 0;
                            f_chkloop=0;  /*forv*/
                            break;  /*Rgߔ*/
                    case 1: /* ch񔭌*/
                            if(*rdworkptr >= '1' && *rdworkptr <= '0'+MAX_CH)
                            {
                                chval = *rdworkptr - 0x30;
                                retcode = 1; /*`lw肠*/
                                rdworkptr++;
                            }
                            else
                            {   retcode = -1;  /*`chR[h*/
                            }
                            f_chkloop=0;  /*forv*/
                            break;

                    case 2: case 3: case 4: case 7: /*rev <20010907p> */
                    case 8: case 9: /* add rev <20020215p> */
                            retcode = i;
                            f_chkloop=0;  /*forv*/
                            break;
                    /*<20010126a>*/
                    case 5:
			    f_remskip=TRUE;   /* on */
                            f_chkloop=0;  /* for break */
                            retcode = 5;  /* coment start */
                            break;
                    /*<20010126a>*/
                    /*case 6:*/
                    /*        f_remskip=false;*/  /*off*/
                    /*        f_chkloop=0; */ /* for break*/
                    /*        retcode = 6; */  /* coment end */
                    /*        break;*/
                }
            }
            else if(i ==6)
            {
                /* <20010126a> */
		f_remskip=FALSE;  /* off */
                f_chkloop=0;  /* for break */
                retcode = 6;  /* coment end */
            }
        }
        if(f_chkloop == 0)break;  /*for*/
    }


    /*<20010126a>*/
    if(f_remskip==TRUE)
    {
        if(*rdworkptr == 0x0d)
        {    retcode = -1; } /*oO(if܂)*/
        else
        {
            retcode = 5;  /*RgX^[g*/
            rdworkptr++;  /*̕ɂ*/
        }
    }

    /*bug*/
    if(retcode < 0 && *rdworkptr == 0x0d)
    {
        retcode = 0;
    }

/*    printf("retcode:%d\n",retcode);*/
    return (retcode);
}

int open_ch(int chno)
{
    if(ch_stack != 0) return -1;
    ch_stack = chno;  /*I[v`lԍL^*/
    return 0;
}
int cdecnv()
{
    int f_cdeloop;
    int ext_err = 0;  /*G[R[h*/
    int cyokuon;  /* <20010106p> */
    int length;  /* <20010114p> */
    int okutabu; /* <20010114p> */
    int okuta;  /* <20010114p> */

    int cde_v = 0;  /* <20010304a> KR[hi[ */
    int f_cdev= 0;  /* <20010304a> 0<>̎cde_val */

    int a;  /* Turbo C <20010627p> */

    /* printf("cdecnv : ");printf(rdworkptr);
    putchar('\n');*/

    f_cdeloop = 1;  /* 1==loop, 0== loopout*/
    /*K(yі߉)*/
    while(f_cdeloop)
    {
        switch(*rdworkptr)
        {
			case ' ':case 0x09:	rdworkptr++;break; /* <20010114p>󔒔΂*/
            case 'C':case 'c': cde_v=MEL_C;f_cdev=1; break; /*h*/
            case 'D':case 'd': cde_v=MEL_D;f_cdev=1; break; /**/
            case 'E':case 'e': cde_v=MEL_E;f_cdev=1; break; /*~*/
            case 'F':case 'f': cde_v=MEL_F;f_cdev=1; break; /*t@*/
            case 'G':case 'g': cde_v=MEL_G;f_cdev=1; break; /*\*/
            case 'A':case 'a': cde_v=MEL_A;f_cdev=1; break; /**/
            case 'B':case 'b': cde_v=MEL_B;f_cdev=1; break; /*V*/
            case 'N':case 'n': /* w <20010106p>*/
                rdworkptr++;
                cyokuon = AscToDec16();  /* Turbo C <20010628a> */
                if(cyokuon >= 0 && cyokuon <= 96)
                {
                    if(ch_stack >= 1 && ch_stack <= MAX_CH)
                    {	length = length_ch[ch_stack-1];
                        ext_err=s_cdestore(cyokuon,t_nagasa[length]);
                    }
                    else
                    {
                        ext_err=999; /* ch I[vĂȂ */
                    }
                }
                else
                {
                    ext_err=12;  /* rev<20010315p> */
                    f_cdeloop = 0;  /* rev<20010315p>[v~ */
                    /* debug */
                    /* ShowMessage("err12"); */
                }
                break;        /* ܂ */

            case 'R':case 'r':  /*x*/
                /*printf("r\n");*/
                rdworkptr++;
                ext_err=s_cdecnv(MEL_MU,l_cdecnv());
                break;

            case 'O':case 'o':  /*IN^[uύX*/
                /*printf("o\n");*/
                rdworkptr++;
                if(*rdworkptr >= '0' && *rdworkptr <= '7')
                {
                    okutabu = *rdworkptr - 0x30;  /*l*/
				    /* <20010114p> add */
					if(ch_stack >= 1 && ch_stack <= MAX_CH)
					{	okutabu_ch[ch_stack-1]=okutabu;	}
					else{ext_err=1;}

                    /*printf("okutabu:%d\n",okutabu); //debug*/
                    rdworkptr++;
                }
                else
                {
                    ext_err = 13;
                }
                break;

            case 'Q':case 'q':  /*ԕύX <20010321p>v0.00.05 */
                /*printf("o\n");*/
                rdworkptr++;
                if(*rdworkptr >= '1' && *rdworkptr <= '8')
                {
                    int q_val = *rdworkptr - 0x30;  /*l*/
					q_val--;  /* tableQƗp0`7ɂ */
					if(ch_stack >= 1 && ch_stack <= MAX_CH)
					{
						ext_err=s_cdestore(250,q_val);
                    }
					else{ext_err=1;}

                    rdworkptr++;
                }
                else
                {
                    ext_err = 19;   /* \pG[R[h */
                }
                break;

            case 'L':case 'l':  /*ύX*/
                /*printf("l\n");*/
                rdworkptr++;
                length = l_lencnv();
                if(length < 0)ext_err = 14;  /*err*/

				/* <20010114p> add */
				if(ch_stack >= 1 && ch_stack <= MAX_CH)
				{	length_ch[ch_stack-1]=length;	}
				else{ext_err=999;}
                break;

            case '@':   /*yԍύX*/
                /* printf("@\n");*/
                rdworkptr++;
                ext_err = n_gakkicnv(); /* ʂ͊OϐgakkiɓĂ */
				/* printf("@ext_err %d",ext_err); */
                if(ext_err == 0)
                {
                    s_ch_gakki(); /*yԍύX Oϐgakki */
                }
                else{ ext_err = 15;}
                break;

            case '>':   /*ނ <20010106p>*/
                rdworkptr++;

				/* <20010114p> add */
				if(ch_stack >= 1 && ch_stack <= MAX_CH)
				{	okuta = okutabu_ch[ch_stack-1];
	                if(okuta < 7) { okuta++;okutabu_ch[ch_stack-1]=okuta;}
				}
				else{ext_err=999;}
                break;  /*܂<20010106p> */

            case '<':   /*ނ <20010106p>*/
                rdworkptr++;
				/* <20010114p> add */
				if(ch_stack >= 1 && ch_stack <= MAX_CH)
				{	okuta = okutabu_ch[ch_stack-1];
	                if(okuta > 0){ okuta--;okutabu_ch[ch_stack-1]=okuta; }
				}
				else{ext_err=999;}
                break;  /*܂<20010106p> */

			/* <20010326a> add v0.00.05 */
    		case '{':
            	rdworkptr++;
            	if(sub_renpu() < 0)
                {	 /* Memo1->Lines->Add("error"); */
                	ext_err=20;
                }
	        	break;

			/* <20010114p> add */
		    case 'V': case 'v':  /* volume */
				rdworkptr++;
				ext_err = n_gakkicnv();
				/*printf("vol:%d\n",ext_err); */
				/*if(ext_err == 0 && gakki >= 0 && gakki <= MAX_VOLUME)*/
				if(ext_err == 0 && gakki <= MAX_VOLUME)
				{
					if(ch_stack >= 1 && ch_stack <= MAX_CH)
					{	volume_ch[ch_stack-1]=gakki;	/* OϐgakkiɓĂ */
						/* fm compiler <20010115p> */
						ext_err=s_cdestore(253,volume_ch[ch_stack-1]);
					}
					else{ext_err=999;}
				}
				else
				{	ext_err=16;
				}
				break;

			/* <20010115p> add */
		    case 'T': case 't':  /* tempo */
				rdworkptr++;
				ext_err = n_gakkicnv();
				if(ext_err == 0 && gakki >= MIN_TEMPO && gakki <= MAX_TEMPO)
				{
					if(ch_stack >= 1 && ch_stack <= MAX_CH)
					{	/* OϐgakkiɓĂ */
						/* fm compiler <20010115p> */
						ext_err=s_cdestore(252,gakki); /* tempo store */
					}
					else{ext_err=999;}
				}
				else
				{	ext_err=17;
				}
				break;

            /* <20010127p> and */
            case '&':
                rdworkptr++;
                if(*rdworkptr!='&') /*AandȂ*/
                {
                    ext_err=s_cdestore(251,0); /* and code store */
                }
                else{ext_err=10;} /*rev<20010127p>*/
                break;

		    case '$':  /* panpot <20010830p> v0.00.06 */
				rdworkptr++;
				ext_err = n_gakkicnv();
				if(ext_err == 0 && gakki <= MAX_PAN)
				{
					if(ch_stack >= 1 && ch_stack <= MAX_CH)
					{	/* OϐgakkiɓĂ */
						ext_err=s_cdestore(249,gakki); /* panpot store */
					}
					else{ext_err=999;}
				}
				else
				{	ext_err=21;  /* panpot error No. */
				}
				break;

            case '\"':rdworkptr++;f_cdeloop=0;  /* " */
                        /*printf("\nend cnv\n");*/
                        break;
            default: return 1;
        }

        /* ==<20010304a>================== */
        if(f_cdev != 0)  /* KR[h̎(cdefgab) */
        {
            rdworkptr++;

            if(*rdworkptr=='#' || *rdworkptr == '+') /* <20010304a> */
            {
                rdworkptr++;
                /* N88BASIC K(B#͓IN^[uCł) */
                if(cde_v < MEL_B){cde_v++;}
                else{cde_v =  MEL_C;}
            }
            else if(*rdworkptr=='-')
            {
                rdworkptr++;
                /* N88BASIC K(C-͓IN^[uBł) */
                if(cde_v > MEL_C){cde_v--;}
                else{cde_v =  MEL_B;}
            }

            if(*rdworkptr==':') /* <20010303p> */
            {
                rdworkptr++;
				a = AscToDec16();  /* Turbo C <20010628a> */
                if(a > 0 && a<=255)
                {
                    if(ch_stack<=0 || ch_stack > MAX_CH)
                    {
                        ext_err=999;
                    }
                    else
                    {
                        int c = cde_v+(okutabu_ch[ch_stack-1]*12);
                        ext_err = s_cdestore(c ,a);
                    }
                }
                else {ext_err=18;}
            }
            else
            {
				/* printf("s_cdecnv req:"); */
                ext_err=s_cdecnv(cde_v ,l_cdecnv());
            }

	    f_cdev = 0;  /*flag reset*/
        }
	/*============================*/

        if(rdworkptr >= rdwork+LINEMAX) f_cdeloop=0;
        if(ext_err != 0)
        {
            /* ShowMessage("ext_err != 0"); */
            return ext_err;
        } /* rev<20010127p> */
    }
    return 0;
}
/*------------------------------------------------*/
int sub_renpu()
{
	int a;
	int i,j;  /* Turbo C <20010627p> */
	int v_onpu; /* Turbo C <20010627p> */
	int m_len,amari,ans; /* Turbo C <20010627p> */
	int ext_err;  /* Turbo C <20010627p> */
	int step; /* Turbo C <20010830p> */
	int f_lp2; /* Turbo C<20010830p> */

	/*debug disp*/
	/* printf("** start { **");*/

	/*reset*/
	for(i=0;i<MAX_RENPU;i++){ work_len[i]=0;work_key[i] = '\0';}

	a = a_cnt(work_key); /*keyi[ret*/

	/* debugdebugdebug */
	/* printf("key:%d\n",a); */

    if(a <= 0)
    {
		/*debug*/
		/*Memo2->Lines->Add("a<=0:err");*/

    	return -1;	/*error*/
    }
    else
    {
		f_lp2 = TRUE;
        while(f_lp2)
        {
			if(*rdworkptr != ' '){ f_lp2 = FALSE;}
		    else{rdworkptr++;} /* skip */
        }
		/*̏̓_~[gp*/
        /*int m_len = 32;*/  /*432*/
		v_onpu = l_cdecnv();
		if(v_onpu < 0){	return -1;}

		/*debug disp*/
       /* printf("v_onpu:%d\n",v_onpu);*/

	m_len = t_nagasa[v_onpu];
	/* int amari;*/  /*܂*/
	/* int ans;*/  /*؂ꂽ*/

        ans = m_len/a;
        amari = m_len - (ans*a);

		/*debug disp*/
        /* printf("m_len:%d  ans:%d  amari:%d\n",m_len,ans,amari);*/
	for(i=0;i<a;i++){ work_len[i]= ans;}

		/*܂肪Ƃs␳*/
        if(amari >= 1)
        {
			step = a/amari; /*[vJEg擾*/
        	/*debug disp*/
			/* printf(" step:%d\n",step);*/
		    for(i=0,j=0;i < amari;i++,j+=step){ work_len[j]++;}  /*inc*/
        }
    }

	/*output*/
    /* int ext_err; */
    for(i=0;i<a;i++)
    {
    	ext_err = s_cdestore(work_key[i],work_len[i]);

		/*printf("key(%d),len(%d)\n",work_key[i],work_len[i]);*/

		if(ext_err < 0)
        {
        	/*debug*/
            /*Memo2->Lines->Add("sub_renpu(){s_cdestore()}:err");*/
        	return -1;
        }
    }
	return 0;  /*no error*/
}
/*-----------------*/
int a_cnt(char *p)
{
	/* *pɒԍi[ */
	int c=0;
	int f_acntlp=TRUE;
	int cdekey=0,param1=0;  /* Turbo C <20010628a> */
	int err_scde;      /* Turbo C <20010628a> */

    if(ch_stack<=0 || ch_stack > MAX_CH) {return -1;}

	while(f_acntlp)
    {
		if(*rdworkptr=='\0' || *rdworkptr== 0x0d){ return -1;}  /*err*/

		cdekey=0;param1=0;

		/* printf("(1)cdekey:%d  param1:%d\n",cdekey,param1); */
		err_scde = sub_cdecnv(&cdekey,&param1);
		/*printf("(2)cdekey:%d  param1:%d\n",cdekey,param1);*/

        if(err_scde != 0)return -1; /*err*/

	  	if(cdekey >= 1 && cdekey<= 12 && err_scde == 0)
        {
			*p = (char)(cdekey+(okutabu_ch[ch_stack-1]*12));
            p++;c++;
        }
        else if(cdekey == 0 && err_scde == 0)
        {
        	*p = 0;  /**/
            p++;c++;
        }
        else if(err_scde == 0 && cdekey >= 14)
        {
			switch(cdekey)
	        {
				case 14: *p = (char)param1;p++;c++;break; /* n */
                case 15: okutabu_ch[ch_stack-1]=param1;break; /* o */
                case 17: return -1;
                case 18: return -1;  /* @ */
                case 19: if(okutabu_ch[ch_stack-1]<7){
                			okutabu_ch[ch_stack-1]++;}break;  /* > */
                case 20: if(okutabu_ch[ch_stack-1]>0){
                			okutabu_ch[ch_stack-1]--;}break;  /* < */
                case 21: return -1;  /* v */
                case 22: return -1;  /* t */
                case 23: return -1;  /* & */
                case 24: return -1;  /* " */
	        }
		}

       	if(c>=MAX_RENPU){ return -1;} /*err*/

        if(*rdworkptr == '}')
        {
			f_acntlp=FALSE;
			rdworkptr++;
        }
	}
	/*debug disp
	//Memo1->Lines->Add("a_cnt retval:"+IntToStr(c));
	*/
	return c;
}
/*----------------------------
//VKǔŊJ<20010325p>
//cdekey͋@\ԍ邽߂̕ϐAhX
//param1͋@\ɑ΂鐔li[邽߂̕ϐAhX
//cdekey=0:x,1`13܂ŉK,14:n,15:o,16:q,17:L,18:@
// 19:>,20:<,21:v,22:t,23:&,24:"
//param1ɂ͒l(0=),K:ԍ,o:q:L:@:v:t:l,
//     0  >,<,&,"
//return 0=no error,<>G[
*/
int sub_cdecnv(int *cdekey,int *param1)
{
	char asc1;
    int f_lp1 = TRUE;
	int f_cdev = 0;  /*p*/

    /* #define rp rdworkptr */

    /*K(yі߉)*/
	/* space skip */
	while(f_lp1)
    {
		if(*rdworkptr == ' ' || *rdworkptr == 0x09){rdworkptr++;}
	else{  	f_lp1 = FALSE; }
    }

	/* oO cdekey = 0;ƂȂĂ̂Ō듮 */
    *cdekey = 0;  /*reset  rev<20010830p> v0.00.06 */

	asc1 = *rdworkptr;

    if(asc1 >= 'a' && asc1 <= 'z'){ asc1=(unsigned char)(asc1 & 0xdf);}

    switch(asc1)
    {
	case 'R':cdekey=MEL_MU;rdworkptr++; *param1=l_cdecnv();break;/*x*/
	    case 'C':*cdekey=MEL_C;f_cdev=1; break; /*h*/
	    case 'D':*cdekey=MEL_D;f_cdev=1; break; /**/
	case 'E':*cdekey=MEL_E;f_cdev=1; break; /*~*/
	case 'F':*cdekey=MEL_F;f_cdev=1; break; /*t@*/
	case 'G':*cdekey=MEL_G;f_cdev=1; break; /*\*/
	case 'A':*cdekey=MEL_A;f_cdev=1; break; /**/
	case 'B':*cdekey=MEL_B;f_cdev=1; break; /*V*/
	case 'N':rdworkptr++;*cdekey=14;*param1= AscToDec16(); /* Turbo C <20010628a> */
			if(*param1<0 && *param1>96){return 1;}break; /* */
	case 'O':rdworkptr++;*cdekey=15;*param1=AscToDec16(); /* Turbo C <20010628a> */
			if(*param1<0 && *param1>7){return 1;}break;/*octύX*/
	case 'Q':rdworkptr++;*cdekey=16;*param1=AscToDec16(); /* Turbo C <20010628a> */
			if(*param1<1 && *param1>8){return 1;}break;/*ύX*/
	case 'L':rdworkptr++;*cdekey=17;*param1=l_lencnv();
			if(*param1<0){return 1;}break;/*ύX*/
	case '@':rdworkptr++;*cdekey=18;*param1=AscToDec16(); /* Turbo C <20010628a> */
			if(*param1<0 && *param1>127){return 1;}break;/*yԕύX*/
	case '>':*cdekey=19;rdworkptr++;break;/*ނ*/
	case '<':*cdekey=20;rdworkptr++;break;/*ނ <20010106p>*/
	    case 'V':rdworkptr++;*cdekey=21;*param1=AscToDec16(); /* Turbo C <20010628a> */
			if(*param1<0 && *param1>MAX_VOLUME){return 1;}break;/* volume */
	    case 'T':rdworkptr++;*cdekey=22;*param1=AscToDec16(); /* Turbo C <20010628a> */
			if(*param1<10 && *param1>240){return 1;}break;/* tempo */
	case '&':rdworkptr++;*cdekey=23;break;
	case '\"':rdworkptr++;*cdekey=24;break; /* " */
        default: return 1;
    }

    if(f_cdev != 0)  /*KR[h̎(cdefgab)*/
    {
        rdworkptr++; /* cdełłɊŶ */

        if(*rdworkptr=='#' || *rdworkptr == '+') /* <20010304a> */
	{   rdworkptr++; if(*cdekey < MEL_B){(*cdekey)++;}else{*cdekey=MEL_C;} /* N88 */
        }
        else if(*rdworkptr=='-')
	{   rdworkptr++; if(*cdekey > MEL_C){(*cdekey)--;}else{*cdekey=MEL_B;}/* N88 */
        }

		/* bcc32Ӗ̖R[hƎwEꂽ̂ŃRg <20010628p> */
        /* f_cdev = 0;*/  /* flag reset */

		*param1 = l_cdecnv();
    }
    /* ============================ */
	return 0;
}
/*------------------*/
void s_ch_gakki()
{
    unsigned char *p; /* Turbo C <20010628a> */

    if(ch_stack == 0) return; /*I[v*/
    if(ch_stack > MAX_CH) return; /* ch over */

    p= chxmem[ch_stack-1];

    p[chxcnt[ch_stack-1]]=(unsigned char)254;  /*FύX*/
    chxcnt[ch_stack-1]++;
    p[chxcnt[ch_stack-1]]=gakki;
    chxcnt[ch_stack-1]++;
}

int close_ch()
{
    /*printf("close_ch\n");*/
    if(ch_stack == 0) return -1;  /*I[vĂȂ̂ɃN[Y*/
    ch_stack = 0;  /*N[Y*/
    return 0;
}

void out_exterr(int errcode)
{
    switch(errcode)
    {
       case 1 : printf("\nIt isn't possible to decipher.\n");break;
       case 10 :printf("\n&  can not continuation\n");break;
       case 11 :printf("\n&  single\n");break;
       case 12 :printf("\ncode 'N?' (0 to 96)\n");break;
       case 13 :printf("\ncode 'O?' (0 to 7)\n");break;
       case 14 :printf("\ncode 'L?' value error\n");break;
       case 15 :printf("\ncode '@?' (0 to 127)\n");break;
       case 16 :printf("\ncode 'V?' (0 to 16)\n");break;
       case 17 :printf("\ncode 'T?' (10 to 250)\n");break;
       case 18 :printf("\ncode ':'  (1 to 255)\n");break;
       case 19 :printf("\ncode 'Q?' (1 to 8)\n");break;
       case 20 :printf("\ncode {} error\n");break;
       case 21 :printf("\ncode '$?' (0 to 127)\n");break; /* v0.00.06 */
       case 22 :printf("\nop ')' not found\n");break; /* v0.00.08 */
       case 23 :printf("\nop :: command not found\n");break; /* v0.00.08 */
       case 24 :printf("\ncr ')' not found\n");break; /* v0.00.09 */
       case 25 :printf("\n string > 63 Byte (over flow)\n");break; /* v0.00.09 */
	   case 26 :printf("\nsn ')' not found\n");break; /* v0.00.10 */
	   case 27 :printf("\n string > 127 Byte(over flow)\n");break; /* v0.00.10 */
       case 999:printf("\nch  not open\n");break;
       default: printf("\n other error\n");break;
    }
}

int n_gakkicnv()
{
	int atai;  /* Turbo C <20010628a> */

	/* printf("n_gakkicnv 1:rdworkptr %d\n",rdworkptr); */
	atai = AscToDec16(); /* Turbo C <20010628a> */
	/* printf("n_gakkicnv 2:rdworkptr %d\n",rdworkptr); */

/*l*/
    if(atai > 255) return -1;  /*over flow*/

    gakki = (unsigned char)atai; /*߂*/
    return 0;
}

int l_lencnv()
{
    int adjust = 0;  /*_t̏ꍇ͒*/
    int retval;  /*߂lp*/
    int len = AscToDec16(); /* Turbo C <20010628a> */

    if(len < 0)return -1;  /*err*/

    switch(len)
    {
        case 1:  retval = L_1; break;
        case 2:  retval = L_2; break;
        case 4:  retval = L_4; break;
        case 8:  retval = L_8; break;
        case 16: retval = L_16; break;
        case 32: retval = L_32; break;
        case 64: retval = L_64; break;
        case 128:retval = L_128; break;
        default :return -1;
    }

    if(*rdworkptr == '.' && len < 128)
    {
        adjust = 1;
	rdworkptr++;  /*next ptr*/
    }
    else if(*rdworkptr == '.' && len == 128)
    {
	return -1;  /*err*/
    }
    return (retval-adjust);
}
/*----------------------*/
/*-<20010214a>--l_cdecnv()ǔ(G~[^)---*/
int l_cdecnv()
{
    int retcode;

    retcode = l_lencnv();  /* ߂lɒ */

    if(retcode < 0) /* lw肪Ȃ(߂l}CiX) */
	{
		/* <20010114p> add */
		if(ch_stack >= 1 && ch_stack <= MAX_CH)
		{
			retcode = length_ch[ch_stack-1];
		}
		else
		{
			retcode = -1;
		}
	}
    return (retcode);
}

int s_cdecnv(int doremi,int onpu)
{
    int onkai;
    char *ch_ptr;
    unsigned long ch_count;
    int nagasa;
    int okutabu;  /* <20010114p> */

	/* <20010114p> add */
	if(ch_stack >= 1 && ch_stack <= MAX_CH)
	{
		okutabu = okutabu_ch[ch_stack-1];
	}
	else
	{
		return -1;  /* error */
	}

    /*h~R[h特KvZ*/
    if(doremi != 0)
	{	onkai = (okutabu*12)+doremi;
    }
    else
	{	onkai = 0;  /*w*/
	}

    /*R[h̒߂*/
    if(onpu >= LEN_MAX || onpu < 0){return -1;}  /*G[*/

    nagasa = t_nagasa[onpu];  /*̒擾*/

	/*debug*/
	/*printf("ch_stack(open ch):%d\n",ch_stack);*/

    /*w`l0̂Ƃ̓`lw*/
    if(ch_stack == 0) return -1;  /*G[*/

    ch_count = chxcnt[ch_stack-1];
    ch_ptr =(char*)chxmem[ch_stack-1];
    chxcnt[ch_stack-1]+=2;

	/* debug */
	/*printf("ch_count:%d\n",ch_count);*/

	/*printf("s_cdecnv 1\n");*/
    /*R[hI[o[t[*/
    if(ch_count >= CH_MEMMAX-1-2)
    {
        printf(" -> ch%d  workarea over.(Max %dbyte)",ch_stack,CH_MEMMAX-1-2);
        return -1;
    }
    ch_ptr[ch_count] = (unsigned char)onkai;
    ch_ptr[ch_count+1]=(unsigned char)nagasa;

    return 0;
}

/* ڊechɊi[ <20010106p>*/
int s_cdestore(int cdecode,int nagasa)
{
    unsigned char *ch_ptr;
    unsigned long ch_count;

    if(cdecode > 255 || nagasa > 255)
    {
        return -1;  /* err */
    }

    /*w`l0̂Ƃ̓`lw*/
    if(ch_stack == 0) return -1;  /*G[*/

    ch_count = chxcnt[ch_stack-1];
    ch_ptr = chxmem[ch_stack-1];
    chxcnt[ch_stack-1]+=2;

    /*R[hI[o[t[*/
    if(ch_count >= CH_MEMMAX-1-2) return -1;

    ch_ptr[ch_count] = (unsigned char)cdecode;
    ch_ptr[ch_count+1]=(unsigned char)nagasa;

    return 0;
}
/*w肵Ԓn̕𐔒lɕϊ*/
int AscToDec16() /* Turbo C ɉ <20010628a> v0.00.05 */
{
    long a=0;    /*ϊli[邽߂̕ϐ*/
    int i;      /*JEgyforp*/

    for(i=0;i<5;i++,rdworkptr++)                /*ő5Ƃ邽i<5*/
    {
	if(*rdworkptr < '0' || *rdworkptr > '9')break;  /*lȊOłbreak*/
        a *= 10;                        /*グ*/
	a += (*rdworkptr&(unsigned char)0x0f);  /* 4bit mask( upper 4bit clear)*/
    }
    if(i==0)return -1;                  /*ŏ琔lłȂƂG[*/
    if(a > 65535) a=65535;              /*16bitEl𒴂ꍇ*/
    return a;
}

int option_set()
{
    /* v0.00.08 op*/
    /*IvV͂tOݒ */
    char work[OPSETWORK+1];

    char *option_name[4] = {"q7def","q8def","autolr","manulr"};
    int option_value[4]  = {OP_Q7DEF,OP_Q8DEF,OP_AUTOLR,OP_MANULR};
    /* AnsiString As1; */

    int retval;  /* ߂li[p (ret:0=noerr,<0=err)*/

    int ssize;  /* token̕擾 */
    int i;     /* Turbo C */
    int f_op_ok; /* Turbo C */

    gettoken(work,OPSETWORK);  /* '(' 𔭌 */
    if(work[0] != '(')
    {
        return -1;
    }


    while(1)
    {
        ssize = gettoken(work,OPSETWORK);

	for(i=0;i<ssize;i++)   /* 啶珬֕ϊ */
        {
            work[i]=(unsigned char)tolower(work[i]);
            /* ShowMessage(work[i]); */
        }
        if(work[0] == ')'){retval = 0;break;}
        if(work[0] == ','){continue;}
        if(ssize <= 0){   retval = 22;break;} /* err return */

	f_op_ok = FALSE;  /* IvVtrue */

	for(i=0;i<4;i++)
        {
            if(strcmp(option_name[i],work)==0)
            {
		printf(" [option]:%s ON\n",option_name[i]);

		/*IvVݒ肷֐*/
                option_checkon(option_value[i]);

		f_op_ok = TRUE; /* IvV */
            }
        }

	if(f_op_ok == FALSE)  /* NG */
        {
            retval = 23;  /* ߂Ȃ */
            break;
        }
    }
    return (retval);
}

/* dos version pɉǂKv */
void option_checkon(int flagno)
{
    int i;   /* turbo c */

    switch(flagno)
    {
	case OP_Q7DEF: f_q_def7 = TRUE; /* 88va݊<20010907p>v0.00.08 */
		for(i=0;i<MAX_CH;i++)
                {   q_ch[i]  = Q_DEF-1;} /* q defalut(Q7:88VA݊) <20010322a> */
                    break;

	case OP_Q8DEF: f_q_def7 =FALSE;
		for(i=0;i<MAX_CH;i++)
                    {   q_ch[i]   = Q_DEF;} /* q  <20010321p> */
                 break; /* 88va݊<20010907p>v0.00.08 */

        case OP_AUTOLR:
	    if(f_auto_lr == FALSE)
		{   f_auto_lr = TRUE;
		    /*SpeedButton12->Down=true;*/
                }
                 break; /* E<20010907p>v0.00.08*/
        case OP_MANULR:
	    if(f_auto_lr == TRUE)
		{   f_auto_lr = FALSE;
		    /* SpeedButton12->Down=false; */
                }
                break; /* E<20010907p>v0.00.08*/
    }
}

/* DOS version rev <20020101p> */
int copyr_set()
{
    /* v0.00.09 cr*/
    /* <20011231a> */

    char work[COPYRMAX+1];

    /*AnsiString As1;*/

    int retval;  /* ߂li[p (ret:0=noerr,<0=err)*/

    int ssize;  /* token̕擾 */

    ssize = gettoken(work,COPYRMAX);  /* '(' 𔭌 */
    if(work[0] != '(' || ssize == 0)
    {
        return -1;
    }
    /* ܂ŋ */

    ssize = gettoken(work,COPYRMAX); /* ' " '𔭌 */
    if(ssize <= 0){ return -1;}
    if(work[0] == ')') { return 0; }
    if(work[0] != '"') { return -1; }
    /* " ̏ */

    copyr_len = 0;  /*  */
 /*   retval = -1;*/  /* (0==noerror) */
    while(1)
    {
        if(*rdworkptr == 0x0d)
        {
            retval = -1;break;
        }
        if(*rdworkptr == '"')
        {
            rdworkptr++;  /* "̎ɂĂ */
            ssize = gettoken(work,COPYRMAX);
            /* debug */
            if(ssize <= 0){return 24;}  /* )ŏIĂȂ */
            if(work[0] == ')' )
            {   retval = 0; /* end */
                break;
            }
            else if(work[0] != '"' )
            {
                return -1; /* error */
            }
        }

        copyr_work[copyr_len]= *rdworkptr;
        copyr_len++;  rdworkptr++;
        if(copyr_len > COPYRMAX)
        {
            copyr_work[copyr_len]= '\0';  /* end code */
            /* rev <20020101p> */
            printf(" [copyright]:\"%s<- MAX\n",copyr_work);

            retval = 25;  /* over flow */
            break;
        }
    }

    if(retval == 0 && copyr_len >= 1)
    {
        f_copyr_sw = TRUE;  /* 쌠\ ON */

        copyr_work[copyr_len]= '\0';  /* end code */
        /* rev <20020101p> */
        printf(" [copyright]:\"%s\" (%d byte)\n",copyr_work,copyr_len);
    }
    return (retval);
}

int sname_set()
{
    /* v0.00.10 sn*/
    /* <20020114p> */

    char work[SNAMEMAX+1];

    /*AnsiString As1;*/

    int retval;  /* ߂li[p (ret:0=noerr,<0=err)*/

    int ssize;  /* token̕擾 */

    ssize = gettoken(work,SNAMEMAX);  /* '(' 𔭌 */
    if(work[0] != '(' || ssize == 0)
    {
        return -1;
    }
    /* ܂ŋ */

    ssize = gettoken(work,SNAMEMAX); /* ' " '𔭌 */
    if(ssize <= 0){ return -1;}
    if(work[0] == ')') { return 0; }
    if(work[0] != '"') { return -1; }
    /* " ̏ */

    sname_len = 0;  /*  */
/*    retval = -1;*/  /* (0==noerror) */
    while(1)
    {
        if(*rdworkptr == 0x0d)
        {
            retval = -1;break;
        }
        if(*rdworkptr == '"')
        {
            rdworkptr++;  /* "̎ɂĂ */
            ssize = gettoken(work,SNAMEMAX);
            /* debug */
            if(ssize <= 0){return 26;}  /* )ŏIĂȂ */
            if(work[0] == ')' )
            {   retval = 0; /* end */
                break;
            }
            else if(work[0] != '"' )
            {
                return -1; /* error */
            }
        }

        sname_work[sname_len]= *rdworkptr;
        sname_len++;  rdworkptr++;
        if(sname_len > SNAMEMAX)
        {
            sname_work[sname_len]= '\0';  /* end code */
			/* rev <20020215p> */
			printf("[sname]:\"%s<- MAX\n",sname_work);

            retval = 27;  /* over flow */
            break;
        }
    }

    if(retval == 0 && sname_len >= 1)
    {
        f_sname_sw = TRUE;  /* V[PX\ ON */

        sname_work[sname_len]= '\0';  /* end code */
		/* rev <20020215p> */
		printf(" [sname]:\"%s\" (%d byte)\n",sname_work,sname_len);
    }
    return (retval);
}

int gettoken(char *p,int bufsize)
{
    int f_loopout = FALSE;
    int ssize = 0;  /*token size */
    int rdcnt; /* ǂݍ݃TCY */
	int f_loopout2;  /* turbo C */
	int cnt;  /* Turbo C */

    while(f_loopout == FALSE)
    {
        if(strlen((char*)rdworkptr) <= 0 || *rdworkptr == 0x0d)
        {
            rdcnt = rd1line();
            rdworkptr = rdwork;
            if(rdcnt <= 0) break;
        }

        /*󔒂TABJbg*/
        while(*rdworkptr == ' ' || *rdworkptr == 0x09)
        {
            rdworkptr++;
        }

        if(*rdworkptr == 0x0d)
        {
            continue;
        }

        /*󔒂TABy0x0d܂ŕ*/
        f_loopout2 = FALSE;
        cnt = strlen((char*)rdworkptr); /*Jn擾*/

        switch(*rdworkptr)
        {
            case '(':*p = *rdworkptr;p++;rdworkptr++;ssize++;f_loopout2=TRUE;
                    *p= '\0';  /*end mark*/
                    break;
            case ')':*p = *rdworkptr;p++;rdworkptr++;ssize++;f_loopout2=TRUE;
                    *p= '\0';  /*end mark*/
                    break;
            case ',':*p = *rdworkptr;p++;rdworkptr++;ssize++;f_loopout2=TRUE;
                    *p = '\0';  /*end mark*/
                    break;
            /* cr߂ɑΉ邽߂ " 1ƂĐ؂o <20011231p>v0.00.09*/
            case '"':*p = *rdworkptr;p++;rdworkptr++;ssize++;f_loopout2=TRUE;
                    *p = '\0';  /*end mark*/
                    break;
        }

        while(f_loopout2 == FALSE)
        {
            if(*rdworkptr == ' ')f_loopout2=TRUE;
            if(*rdworkptr == 0x09)f_loopout2=TRUE;
            if(*rdworkptr == 0x0d)f_loopout2=TRUE;
            if(*rdworkptr == 0x0a)f_loopout2=TRUE;
            if(*rdworkptr == ',')f_loopout2=TRUE;
            if(*rdworkptr == ')')f_loopout2=TRUE;
            if(ssize >= bufsize)f_loopout2=TRUE;
            if(ssize >= cnt)f_loopout2 =TRUE;
            if(f_loopout2 == FALSE)
            {
                *p = *rdworkptr;
                p++;
                *p = '\0'; /*KŌ0*/
                rdworkptr++;
                ssize++;
            }

        }
        f_loopout = TRUE; /*[vI*/
    }
    return (ssize);
}
